function varargout = brinst1_ui(varargin)
% Last Modified by GUIDE v2.5 16-Dec-2005 14:45:08

if nargin == 0  % LAUNCH GUI

  fig = openfig(mfilename,'reuse');
  %set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));
  %changeuicolor(fig)

  % Generate a structure of handles to pass to callbacks, and store it. 
  handles = guihandles(fig);

  % STARTUP code ----
  set(gcf, 'HandleVisibility', 'on');
  set(gcf, 'CloseRequestFcn', 'brinst1_ui(''exit_Callback'',gcf,[],guidata(gcf))');
  set_figstate('idle', handles);

  param = [];
  paramfile = 'expar13.data';
  try
    [param.a1, param.d1, param.amp1, param.label1] = textread(paramfile,'%f%f%f%q%*[^\n]', 'commentstyle','matlab');
    set(handles.popup_sample,'String',param.label1);
  catch
    herr = errordlg(['Cant read a example parameters file: ', ...
                     paramfile,'.'],'Error');
    uiwait(herr)
  end

  paramfile = 'expar14.data';
  try
    [param.a2, param.d2, param.amp2, param.label2] = textread(paramfile,'%f%f%f%q%*[^\n]', 'commentstyle','matlab');
  catch
    herr = errordlg(['Cant read a example parameters file: ', ...
                     paramfile,'.'],'Error');
    uiwait(herr)
  end
  
  param.itype = 1;
  
  handles.param = param;
  setparam(handles,1);
  % STARTUP code ----
  
  guidata(fig, handles);

  if nargout > 0
    varargout{1} = fig;
  end

else
  if ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK
    try
      if (nargout)
        [varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
      else
        feval(varargin{:}); % FEVAL switchyard
      end
    catch
      disp(lasterr);
    end
  end
  return
end


init_graphics(handles)
return

% --------------------------------------------------------------------
% invoked to show initial values
function init_graphics(handles)

% If the program is running or pausing or trying to stop calculation
ud = get(gcf, 'UserData');
if ~strcmp(ud, 'idle')
  return
end

% To show initial state, call the calculation and drawing routines with
% nstep = 0.
nstep =get(handles.edit12,'String');
set(handles.edit12,'String',0);
start_Callback([], [], handles)
set(handles.edit12,'String',nstep);

return;


% --------------------------------------------------------------------
% get values from EDIT BOXES
function p = getparams(handles)

p.err = 0;

% get values from EDIT BOXES
if get(handles.radiobutton1,'Value')
  p.itype = 1;
else
  p.itype = 2;
end

p.a = str2double(get(handles.edit1,'String'));
p.d = str2double(get(handles.edit2,'String'));
p.amp = str2double(get(handles.edit3,'String'));

p.dt = str2double(get(handles.edit11,'String'));
p.nstep = str2double(get(handles.edit12,'String'));
p.grid = str2double(get(handles.edit13,'String'));



% If a parameter is not numerical, return after showing an error message.
if isnan(p.a) | isnan(p.d)
  errordlg('Input parameters must be numerical characters.');
  p.err = 1;
end

return

% --------------------------------------------------------------------
function setparam(handles,n)

if ~isempty(handles.param)
  if handles.param.itype == 1
    set(handles.edit1,'String',handles.param.a1(n));
    set(handles.edit2,'String',handles.param.d1(n));
    set(handles.edit3,'String',handles.param.amp1(n));
  else
    set(handles.edit1,'String',handles.param.a2(n));
    set(handles.edit2,'String',handles.param.d2(n));
    set(handles.edit3,'String',handles.param.amp2(n));
  end
end
return;


% --------------------------------------------------------------------
function varargout = popup_sample_Callback(h, eventdata, handles, varargin)

n = get(h,'Value');
setparam(handles,n);
init_graphics(handles)

return;


% --------------------------------------------------------------------
function varargout = edit_Callback(h, eventdata, handles, varargin)
init_graphics(handles)
return


% --------------------------------------------------------------------
function varargout = radiobutton1_Callback(h, eventdata, handles, varargin)

if ~get(h,'Value')
  set(h,'value',1);
  return
end

set(handles.radiobutton2,'Value',0);

handles.param.itype = 1;
guidata(gcf, handles);

set(handles.popup_sample,'Value',1);
set(handles.popup_sample,'String',handles.param.label1);
setparam(handles,1);
init_graphics(handles)

return;


% --------------------------------------------------------------------
function varargout = radiobutton2_Callback(h, eventdata, handles, varargin)

if ~get(h,'Value')
  set(h,'value',1);
  return
end

set(handles.radiobutton1,'Value',0);

handles.param;
handles.param.itype = 2;
guidata(gcf, handles);

set(handles.popup_sample,'Value',1);
set(handles.popup_sample,'String',handles.param.label2);
setparam(handles,1);
init_graphics(handles)

return


% --------------------------------------------------------------------
% --------------------------------------------------------------------
% --------------------------------------------------------------------
function set_figstate(newstate, handles)
set(gcf, 'UserData', newstate);
ud = get(gcf, 'UserData');
switch ud
    case 'idle' % ready to change parameters, start calculation or exit
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [1.0 1.0 1.0]);
        set(handles.start, 'String', '[> START');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'off');
        set(handles.exit, 'Enable', 'on');
    case 'run' % executing calculation
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'popupmenu'), 'Enable', 'off');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'Enable', 'inactive');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [0.8 0.8 0.8]);
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'radiobutton', 'Value', 0.0), 'Enable', 'off');
        set(handles.start, 'String', '{}{} PAUSE');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'on');
        set(handles.exit, 'Enable', 'off');
    case 'pause' % uiwait (waiting for uiresume)
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'popupmenu'), 'Enable', 'off');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'Enable', 'inactive');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [0.8 0.8 0.8]);
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'radiobutton', 'Value', 0.0), 'Enable', 'off');
        set(handles.start, 'String', '[>RESUME');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'on');
        set(handles.exit, 'Enable', 'off');
    case 'stop' % trying to stop calculation
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'off');
    case 'exit' % trying to exit
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'off');
    otherwise
        herr = errordlg(['Error: unknown FIGSTATE = [' ud ']']);
        uiwait(herr);
end
return;

% --------------------------------------------------------------------
function start_Callback(hObject, eventdata, handles)
ud = get(gcf, 'UserData');
switch ud
    case 'idle' % --> START
        set_figstate('run', handles);
        p = getparams(handles); % load parameters set in GUI
        if p.err
          return;
        end
        brinst1(p.itype, p.a, p.d, p.amp, p.dt, p.nstep, p.grid);
        ud = get(gcf, 'UserData');
        if strcmp(ud, 'exit')
            delete(gcf);
            return;
        end
        set_figstate('idle', handles);
    case 'run' % --> PAUSE
        set_figstate('pause', handles);
        uiwait(gcf);
    case 'pause' % --> RESUME
        set_figstate('run', handles);
        uiresume(gcf);
    case 'stop' % --> do nothing
        return;
    case 'exit' % --> do nothing
        return;
    otherwise
        herr = errordlg(['Error: unknown FIGSTATE = [' ud ']']);
        uiwait(herr);
end
return;

% --------------------------------------------------------------------
function stop_Callback(hObject, eventdata, handles)
%set(gcf, 'Name', 'Linear Advection and Diffusion - Please wait for stopping...');
set_figstate('stop', handles);
uiresume(gcf);
return;

% --------------------------------------------------------------------
function exit_Callback(hObject, eventdata, handles)
ud = get(gcf, 'UserData');
if strcmp(ud, 'idle')
    delete(gcf);
    return;
else
    set_figstate('exit', handles);
    uiresume(gcf);
end
return;


% --------------------------------------------------------------------
function edit1_Callback(hObject, eventdata, handles)
function edit2_Callback(hObject, eventdata, handles)
function edit3_Callback(hObject, eventdata, handles)
function edit11_Callback(hObject, eventdata, handles)
function edit12_Callback(hObject, eventdata, handles)
function edit13_Callback(hObject, eventdata, handles)
