function handles = m1grph(t,z, handles)
  global im jm
  persistent hfig hax1 hax2 hax3 cmax cmin

  %
  g=p2s2ga(jm,im,z);
  gt=g';
  gt(im+1,:)=gt(1,:);
  gt(:,jm+1)=gt(:,1);
  x=(0:im)/im;
  y=(0:jm)/jm;  

  %
  [u,v]=p2s2va(jm,im,z);
  vt=v';
  %vt=v;
  vt(im+1,:)=vt(1,:);
  vt(:,jm+1)=vt(:,1);
  ut=u';
  %ut=u;
  ut(im+1,:)=ut(1,:);
  ut(:,jm+1)=ut(:,1);

  %
  xx = linspace(0,im/im,21);
  yy = linspace(0,jm/jm,21);
  [xg,yg] = meshgrid(xx,yy);
  vti = griddata(x,y,vt,xg,yg);
  uti = griddata(x,y,ut,xg,yg);
  
  %
  gy = mean(gt,1);
  uy = mean(ut,1);

  %st=num2str(t);
  stitle=sprintf('T=%4.2f',t);

  %
  if exist('OCTAVE_VERSION') == 0
     % matlab
     if t == 0
       hfig = gcf;
       set(hfig,'DoubleBuffer','on')
       hax1 = findobj(hfig,'Tag','axes1');
       hax2 = findobj(hfig,'Tag','axes2');
       hax3 = findobj(hfig,'Tag','axes3');
	     set(hax1,'YDir','default');
  	   set(hax1,'TickDir','out');
	     set(hax1,'NextPlot','replacechildren');
	     set(hax2,'yticklabel','')
  	   set(hax2,'NextPlot','replacechildren');
	     set(hax3,'yticklabel','')
    	 set(hax3,'NextPlot','replacechildren');
       colormap(jet(256))
       
       cmax = max(max(abs(g)));
       cmin = -cmax;
     end
     
     %axes(hax1)
     set(gcf, 'CurrentAxes', hax1);
     cla
     hold on
     himg = imagesc(x,y,gt');
     caxis([cmin, cmax]);
     quiver(xg,yg,uti',vti','w')
     hold off

     %colorbar
     axis equal
     axis([x(1),x(im+1),y(1),y(jm+1)])

     xlabel('X')
     ylabel('Y')
     title(stitle);


     %
     %axes(hax2);
     set(gcf, 'CurrentAxes', hax2);
     cla
     hold on
     plot(gy,y,'k-');
     hold off
     box on
     title('z','FontName','Symbol')

     %axes(hax3);
     set(gcf, 'CurrentAxes', hax3);
     cla
     hold on
     plot(uy,y,'k-');
     hold off
     box on
     title('u');

     drawnow;
   else
     % octave
     title(stitle);
     contour(x,y,gt,11); % octave 2.1
%     contour(gt,11,x,y); % octave 2.0
   end
   
   handles.fig = hfig;
return;
