% Barotropic instability 1 (vortex layer)
function brinst2(varargin)
  global im dq
  
  im=512;
  %km=170; % Too large km will cause numerical instability with this settings of experiment.
           % km should be less than 1/3 of im.

  nstep=1000;
  h=0.25;
  m=1;

  r1=1;    % radius of inner circle
  r2=1.25; % radius of outer circle

  dq(1)=-2*pi;
  dq(2)=2*pi;

  %
  for k = 1:length(varargin)  
    var = varargin{k};
    if isempty(var)
      continue
    end
    switch k
     case 1
      r1 = var;
     case 2
      r2 = var;
     case 3
      dq(1) = var*pi;
     case 4
      dq(2) = var*pi;
     case 5
      h = var;
     case 6
      nstep = var;
     case 7
      im = var;
    end
  end
  
  %
  km = fix(im/4);
  k=1:km;
  k2=-km:km;
  kw=[im-km+k-1,0:km];
  z=zeros(2*km+1,2);

  zi=sqrt(-1);

  z(1+km+1,1)=1;    % radius of inner circle
  z(1+km+1,2)=1.25; % radius of outer circle

  z=z+1e-6; % arbitrary initial perturbation

  %
  fm=2; % size of frame for drawing
  
  t=0;
  z=c2rdst(z);
  handles = c2grph(t,z,fm);
  for istep=1:nstep
    drawnow;
    [t,z]=tdrk4u(m,h,t,z,'c2fun');
    z=c2rdst(z);

    ud = get(gcf, 'UserData');
    if strcmp(ud, 'stop') || strcmp(ud, 'exit')
      return;
    end
    drawnow;
    handles = c2grph(t,z,fm);
  end
