% Barotropic instability 2 (two vortex layers related to jet)
function brinst3(varargin)
  global im dq
  
  im=512;
  %km=170; % Too large km will cause numerical instability with this settings of experiment.
           % km should be less than 1/3 of im. 

  nstep=1000;
  h=0.25;
  m=1;

  r0=1;    % radius of the most inner circle
  r1=1.25; % radius of the middle circle
  r2=1.5;  % radius of the most outer circle

  q1=2*pi; % vorticity for r0<r<r1

  %
  for k = 1:length(varargin)  
    var = varargin{k};
    if isempty(var)
      continue
    end
    switch k
     case 1
      r0 = var;
     case 2
      r1 = var;
     case 3
      r2 = var;
     case 4
      q1 = var*pi;
     case 5
      h = var;
     case 6
      nstep = var;
     case 7
      im = var;
    end
  end
  
  km = fix(im/4);
  k=1:km;
  k2=-km:km;
  kw=[im-km+k-1,0:km];
  z=zeros(2*km+1,3);

  %
  q2=-q1*(r1^2-r0^2)/(r2^2-r1^2);   % vorticity for r1<r<r2

  z(1+km+1,1)=r0; 
  z(1+km+1,2)=r1;
  z(1+km+1,3)=r2;
    
  z=z+1e-6; % arbitrary initial perturbation
  
  dq(1)=-q1;
  dq(2)=q1-q2; 
  dq(3)=q2;

  %
  fm=2; % size of frame for drawing
  
  %
  t=0;
  z=c2rdst(z);
  handles = c2grph(t,z,fm);
  for istep=1:nstep
    drawnow;
    [t,z]=tdrk4u(m,h,t,z,'c2fun');
    z=c2rdst(z);
    
    ud = get(gcf, 'UserData');
    if strcmp(ud, 'stop') || strcmp(ud, 'exit')
      return;
    end
    drawnow;
    c2grph(t,z,fm);
  end
