%*****************************************************************************
% Subroutine for generating random numbers obeying normal distribution
%
% HISTORY
%   ????       Ryo Mizuta
%   2004/05/29 Koichi Shin (RISH) (convert to MATLAB code)
%
% REFERENCE
%   Numerical Recipes
%*****************************************************************************
function srand = rand_nr(iseed)

%v1 = 2.*rngu3(iseed) - 1.
%v2 = 2.*rngu3(iseed) - 1.

v = 2.0*rand(1,2)-1.0;
r = sum(v.^2);

while r >= 1
  v = 2.0*rand(1,2)-1.0;
  r = sum(v.^2);
end

factor = sqrt( -2.0*log(r)/r );

srand = v.*factor;

return

