% CONV  Thermal Convection
%
% conv(alpha, beta, nu, kappa)
%
function conv(nu, kappa, alpha, dte, d)

  imx=128; jmx=64;
  imx=64; jmx=32;
  %dt = 0.005;

  xmax = 1.0;
  zmax = 0.5;

  zmax = 1.0; % d
  zmax = d;
  xmax = zmax*2;

  g = 9.8;
  alpha = alpha*g;

  %***********[SATO]*************
  time_scale = 0.3 * d^2 / kappa;
  % time scale of thermal diffusion to be calculated
  
  kmx = pi / (xmax / imx);  % pi / (grid size of x direction) 
  lmx = pi / (zmax / jmx);  % pi / (grid size of z direction)
  %dt = 0.5 * min( 1/nu, 1/kappa ) / (kmx^2 + lmx^2); % Sakai sensei
  %dt = 0.8 * min( 1/nu, 1/kappa ) / (kmx^2 + lmx^2); % Sakai sensei
  %dt = 2.0 * min( 1/nu, 1/kappa ) / (kmx^2 + lmx^2); % slightly changed
  dt =  5.0 * min( 1/nu, 1/kappa ) / (kmx^2 + lmx^2); % K. Sato 2005/12/16

  output_times       = 600; % number of times to output graphics
  tmx                = ceil( time_scale / dt ); % total number of time steps
  t_step_in_a_output = ceil( tmx / output_times ); % tmx / output_times
  
  %dte = -10; % delta thermal
  %beta=-20.0;
  %nu=5.0e-3;
  %kappa=5.0e-3;

  p = convection(alpha, dte, nu, kappa,imx,jmx,xmax,zmax,dt);

  % ----- initialize graphics -----
  h = gcf;

  hfig = grinit;
  
  %  ---- time integration ----
  for ii=1:output_times
    for jj=1:t_step_in_a_output
      drawnow;
      ud = get(gcf, 'UserData');
      if strcmp(ud, 'stop') || strcmp(ud, 'exit')
        return;
      end
      
      p = runge_kutta(p);
    end

    ppsi = poisson(p.fac, p.zeta);

    if max(isfinite(ppsi(2:(end-1),2:(end-1)))) == 0
      set(gcf, 'Visible', 'off');
      h = errordlg('Data overflow','Error');
      waitfor(h);
      set(gcf, 'Visible', 'on');
      return
    end
    %ppsi
    drawnow;
    gr(p, ppsi',hfig);
  end

return;
