%------------------------------------------------------
% convection class
%------------------------------------------------------
function p = convection(a,dte,nu,k,imx,jmx,xmax,zmax,dt)
    %p.imx=64;    p.jmx=32;
    p.imx = imx;
    p.jmx = jmx;
    
    p.im0=p.imx-1; p.jm0=p.jmx-1;
    p.im1=p.imx+1; p.jm1=p.jmx+1;

    p.xmax = xmax; p.zmax = zmax;

    %real :: p_time=0., dt, alpha=1., beta=-20., nu=5.e-3, kappa=5.e-3
    p.p_time=0.;
    p.dt = dt;
    
    
    %p.alpha=1.;
    %p.beta=-20.;
    %p.nu=5.e-3,;
    %p.kappa=5.e-3;
    

    p.alpha=a;
    p.dte = dte;
    p.beta= -dte/zmax;

    p.nu=nu;
    p.kappa=k;
    
    %real :: psi(im1,jm1), zeta(im0,jm0), temp(imx,jmx), x(im1), z(jm1)
    %real, private ::wx(imx*3+15), wz(jmx*3+15), fac(im0, jm0)
    
    p.fac = zeros(p.im0, p.jm0);
    p.zeta = zeros(p.im0, p.jm0);
    p.temp = zeros(p.imx, p.jmx);
    
    % seed
    %p.temp(32, 16) = 1.e-1;
    % K. Sato 2005/12/16
    l = round(p.im0 * 0.4);
    r = round(p.im0 * 0.6);
    b = 1;
    t = round(p.jm0 * 0.2);
    for i = l : r
        for j = b : t
            p.temp(i,j) = dte * 0.1;
        end
    end

    % Rayleigh number
    p.ra = (p.alpha*p.dte*(zmax^3))/(nu*k);
    % Prandtl number
    p.pr = nu/k;
    
    %sprintf('Re=%5.1f, Pr=%5.1f',p.ra,p.pr)
    
    %------------------- setup data ----------------------
    p.dx = p.xmax/p.imx;
    p.dz = p.zmax/p.jmx;

    p.x = p.dx*(0:p.imx);
    p.z = p.dz*(0:p.jmx);

    for i=1:p.im0
      xk = pi/xmax*i;
      for j=1:p.jm0
        zl = pi/p.zmax*j;
        p.fac(i,j) = -1.0 /(xk*xk + zl*zl)/(4.*p.imx*p.jmx);
      end
    end

    %p = class(p,'convection');
    
return

