%------------------ graphic output ------------------
function gr(p, psi, hfig)

ttt = t_all(p);
tave = mean(ttt,2);
tave2 = [tave,tave];

%if isempty(get(gca,'UserData'))
  hax = get(gca,'UserData');

  if isempty(hax)
    % ---
    pos = get(gca,'Position');
  
    %----
    pos1 = pos;
    pos1(3) = pos1(3)*0.8;
    hax(1) = axes('Position',pos1);
    set(gca,'PlotBoxAspectRatio',[p.xmax p.zmax 1]);
    
    pos2 = [pos(1)+pos(3)*0.9, pos(2), pos(3)*0.1, pos(4)];
    hax(2) = axes('Position',pos2);
    set(hax(2),'PlotBoxAspectRatio',[pos2(3)/pos1(3)*p.xmax p.zmax 1]);
    %----
  else
    set(gcf,'CurrentAxes',hax(1)); %axes(hax(1))
    pos1 = get(hax(1),'Position');
    cla

    set(gcf,'CurrentAxes',hax(2)); %axes(hax(2))
    pos2 = get(hax(2),'Position');
    cla
  end

    set(gcf,'CurrentAxes',hax(1)); %axes(hax(1))
  
    hax(3) = pcolor(p.x,p.z, ttt);
    caxis([-p.zmax*abs(p.beta), 0.0])
    shading interp

    %axis equal
    set(hax(1),'PlotBoxAspectRatio',[p.xmax p.zmax 1]);
    axis([0,p.xmax,0,p.zmax,-1,2]);

    set(gca,'TickDir','out')
    xlabel('X [m]');
    ylabel('Z [m]');
    view(0,90)

  %--- return to main figure
  %set(hax(3),'xdata',p.x,'ydata',p.z,'cdata', ttt);

  ccmax = max(max(abs(psi)));
  cmax = 10^(floor(log10(ccmax)));

  %if cmax >= 0.000001
  %if cmax >= p.nu
  if cmax >= 1.0e-15
    idx = fix(ccmax/cmax);
    c = [0.5, 1, 1, 2, 2, 2, 2.5, 2.5, 2.5];
    b = 0:cmax*c(idx):cmax*10;
    a = fliplr(0:-cmax*c(idx):-cmax*10);
    cv = [b(1:end-1),a];
    cdiff = cmax*c(idx);
  else
    cdiff = 1;
    cv = -1:cdiff:1;
  end

  %--- contour ---
  hold on
  [cs, hcb] = contour(p.x, p.z, psi, cv,'k-');
    
  if ~isempty(hcb)
    %--- change line
    for ii=1:length(hcb)
      ud = get(hcb(ii),'UserData');
      if ud < 0
        set(hcb(ii),'LineStyle','--')
      end
    end

    %--- contour label ----
    hcl = clabel(cs, hcb,'labelspacing',500);
    for ii=1:length(hcl)
        pos = get(hcl(ii),'Position');
        pos(3) = 1.0;
        set(hcl(ii),'Position',pos)
    end
  end
  hold off
  
  
  % Title ------
  msg = sprintf('Time= %5.3fsec, Ra=%g, Pr=%3.1f, Cont.=%g', ...
                p.p_time, p.ra, p.pr,cdiff);
  title(msg);

  
    % T average ----------
    set(gcf,'CurrentAxes',hax(2)); %axes(hax(2))

    %hta = pcolor([-p.dte, 0],p.z, tave2);
    hta = pcolor([0,1],p.z, tave2/(p.dte));
    shading interp

    hold on
    hplot = plot(tave/p.dte+1, p.z,'k-');
    %hplot = plot(tave, p.z,'k-');
    hold off
    %xlabel('T');

    xlabel('T / \Delta T');

    title('Ave.')
    set(gca,'TickDir','out')
    set(gca,'YTickLabel','')
    set(hax(2),'PlotBoxAspectRatio',[pos2(3)/pos1(3)*p.xmax p.zmax 1]);
    

% Draw page --
drawnow

set(gca,'UserData',hax)

return;

