function varargout = deform1_ui(varargin)
% Last Modified by GUIDE v2.5 14-Dec-2005 22:38:45

if nargin == 0  % LAUNCH GUI

  fig = openfig(mfilename,'reuse');
  %set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));
  changeuicolor(fig)

  % Generate a structure of handles to pass to callbacks, and store it. 
  handles = guihandles(fig);

  % STARTUP code ---- begin
  set(gcf, 'HandleVisibility', 'on');
  set(gcf, 'CloseRequestFcn', 'deform1_ui(''exit_Callback'',gcf,[],guidata(gcf))');
  set_figstate('idle', handles);

  param = [];
  paramfile = 'expar1.data';
  try
    [param.u0, param.dudx, param.dudy, param.v0, param.dvdx, param.dvdy, param.label] = textread(paramfile,'%f%f%f%f%f%f%q%*[^\n]', 'commentstyle','matlab');
    set(handles.popup_sample,'String',param.label);
  catch
    herr = errordlg(['Cant read a example parameters file: ', ...
                     paramfile,'.'],'Error');
    uiwait(herr)
  end

  handles.param = param;
  setparam(handles,1);
  % STARTUP code ---- end

  guidata(fig, handles);

  if nargout > 0
    varargout{1} = fig;
  end

else
  if ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

  try
    if (nargout)
      [varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
    else
      feval(varargin{:}); % FEVAL switchyard
    end
  catch
    disp(lasterr);
  end
  end
  return;
end

graph0(handles); % display initial values
return;

% --------------------------------------------------------------------
function graph0(handles)

% If the program is running or pausing or trying to stop calculation
ud = get(gcf, 'UserData');
if ~strcmp(ud, 'idle')
  return
end

% load parameters set in GUI
p = getparams(handles);
if p.err
  return
end

% To show only the initial state, 
% call the calculation and drawing routines with nstep = 0.
deform1(p.u0,p.dudx,p.dudy, p.v0,p.dvdx,p.dvdy,0,0);

return;

% --------------------------------------------------------------------
% load values from EDIT BOXES
function p = getparams(handles)

p.err = 0;

% load values from EDIT BOXES
p.u0 = str2double(get(handles.edit1,'String'));
p.dudx = str2double(get(handles.edit2,'String'));
p.dudy = str2double(get(handles.edit3,'String'));

p.v0 = str2double(get(handles.edit4,'String'));
p.dvdx = str2double(get(handles.edit5,'String'));
p.dvdy = str2double(get(handles.edit6,'String'));

p.dt = str2double(get(handles.edit8,'String'));
p.nmax = str2double(get(handles.edit9,'String'));

if isnan(p.u0) | isnan(p.dudx) | isnan(p.dudy) |isnan(p.v0) | isnan(p.dvdx) | isnan(p.dvdy)
  errordlg('Input parameters must be numerical characters.');
  p.err = 1;
end

return

% --------------------------------------------------------------------
function setparam(handles,n)

if ~isempty(handles.param)
  set(handles.edit1,'String',handles.param.u0(n));
  set(handles.edit2,'String',handles.param.dudx(n));
  set(handles.edit3,'String',handles.param.dudy(n));

  set(handles.edit4,'String',handles.param.v0(n));
  set(handles.edit5,'String',handles.param.dvdx(n));
  set(handles.edit6,'String',handles.param.dvdy(n));
end

return;


% --------------------------------------------------------------------
function varargout = popup_sample_Callback(h, eventdata, handles, varargin)
n = get(h,'Value');
setparam(handles,n);

graph0(handles)
return;

% --------------------------------------------------------------------
function varargout = edit_Callback(h, eventdata, handles, varargin)
graph0(handles)


% --------------------------------------------------------------------
% --------------------------------------------------------------------
% --------------------------------------------------------------------
function set_figstate(newstate, handles)
set(gcf, 'UserData', newstate);
ud = get(gcf, 'UserData');
switch ud
    case 'idle' % ready to change parameters, start calculation or exit
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [1.0 1.0 1.0]);
        set(handles.start, 'String', '[> START');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'off');
        set(handles.exit, 'Enable', 'on');
    case 'run' % executing calculation
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'popupmenu'), 'Enable', 'off');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'Enable', 'inactive');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [0.8 0.8 0.8]);
        set(handles.start, 'String', '{}{} PAUSE');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'on');
        set(handles.exit, 'Enable', 'off');
    case 'pause' % uiwait (waiting for uiresume)
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'popupmenu'), 'Enable', 'off');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'Enable', 'inactive');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [0.8 0.8 0.8]);
        set(handles.start, 'String', '[>RESUME');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'on');
        set(handles.exit, 'Enable', 'off');
    case 'stop' % trying to stop calculation
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'off');
    case 'exit' % trying to exit
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'off');
    otherwise
        herr = errordlg(['Error: unknown FIGSTATE = [' ud ']']);
        uiwait(herr);
end
return;

% --------------------------------------------------------------------
function start_Callback(hObject, eventdata, handles)
ud = get(gcf, 'UserData');
switch ud
    case 'idle' % --> START
        set_figstate('run', handles);
        %
        p = getparams(handles); % load parameters set in GUI
        if p.err
            return
        end
        deform1(p.u0,p.dudx,p.dudy, p.v0,p.dvdx,p.dvdy,p.dt,p.nmax);
        %
        ud = get(gcf, 'UserData');
        if strcmp(ud, 'exit')
            delete(gcf);
            return;
        end
        set_figstate('idle', handles);
    case 'run' % --> PAUSE
        set_figstate('pause', handles);
        uiwait(gcf);
    case 'pause' % --> RESUME
        set_figstate('run', handles);
        uiresume(gcf);
    case 'stop' % --> do nothing
        return;
    case 'exit' % --> do nothing
        return;
    otherwise
        herr = errordlg(['Error: unknown FIGSTATE = [' ud ']']);
        uiwait(herr);
end
return;

% --------------------------------------------------------------------
function stop_Callback(hObject, eventdata, handles)
%set(gcf, 'Name', 'Linear Advection and Diffusion - Please wait for stopping...');
set_figstate('stop', handles);
uiresume(gcf);
return;

% --------------------------------------------------------------------
function exit_Callback(hObject, eventdata, handles)
ud = get(gcf, 'UserData');
if strcmp(ud, 'idle')
    delete(gcf);
    return;
else
    set_figstate('exit', handles);
    uiresume(gcf);
end
return;



function edit1_Callback(hObject, eventdata, handles)

function edit2_Callback(hObject, eventdata, handles)

function edit3_Callback(hObject, eventdata, handles)

function edit4_Callback(hObject, eventdata, handles)

function edit5_Callback(hObject, eventdata, handles)

function edit6_Callback(hObject, eventdata, handles)

function edit8_Callback(hObject, eventdata, handles)

function edit9_Callback(hObject, eventdata, handles)
