%******************************************************************************
% TITLE
%   Geophysical Fluid Dynamics - Computer Exercises -
%
%   Fluid parcel in steady flow from Lagrange view (2)
%   Rotation
%
% HISTORY
%   1999/04/24 Tomonori Ohmiya
%   1999/05/11 Shigeo Yoden
%   2004/05/24 Koichi Shin (RISH) (convert to MATLAB code)
%******************************************************************************
function dx = fcn2(n,t,x,dx)
global omega redge;
r = sqrt( x(1,:).^2 + x(2,:).^2 );

for ii = 1:length(r)
  if r(ii) <= redge
    vtan(ii) = r(ii) * omega;
  else
    vtan(ii) = redge^2 * omega/r(ii);
  end
end

theta =   sign(x(2,:)) .* acos(x(1,:)./r);

dx = [-vtan.*sin(theta); vtan.*cos(theta)];
return
%*****************************************************************************
