%*-----------------------------------------------------------------------
%*    Runge-Kutta driver (Uniform step)
%*-----------------------------------------------------------------------
%*     Copyright (C) 2000 GFD Dennou Club. All rights reserved.
%*-----------------------------------------------------------------------
function x = odrkdu(n, algr, fcn, t, tend, istep, x)

%      dimension  x(n), work(n,*)
%*                      work(n,2) for rkg, odrk2, odrk1
%*                      work(n,4) for odrk4
%      external   fcn, algr
      work1 = zeros(size(x));

      %if n < 1
      %	disp('e', 'odrkdu', 'invalid n.')
      %	return
      %end

      t0 = t;
      dt = (tend-t0)/istep;
      
      
      for j=1:istep
        work1 = feval(fcn, n, t, x, work1 );

        x = feval(algr, n, fcn, t, dt, x, work1);

        t = t0 + dt*j;
      end
return
