%------------------ graphic output ------------------
function handles = gr1_init(xh,ht,xuv,u,v,ii,t)

global dt itmax
  
% ----- initialize graphics -----
handles.fig = gcf;

set(handles.fig,'DoubleBuffer','on')
set(handles.fig,'BackingStore','off')
set(gca,'NextPlot','replacechildren');

% Erase axes in figure, unless the UserData exists (for GUI).
hh = get(handles.fig,'Children');
for l = 1:length(hh)
  if strcmp(get(hh(l),'Type') ,'axes')
    if isempty(get(hh(l),'UserData'))
      delete(hh(l))
    end
  end
end


%
h = ht(ii,:);
tt = 0:dt:(dt*itmax);

pos = get(gca,'Position');

% display wave form
handles.hax1 = axes('Position',[pos(1), pos(2)+pos(4)*0.52,pos(3),pos(4)*0.48]);
set(handles.hax1,'NextPlot','replacechildren');

handles.hh = plot(xh,h,'k-','LineWidth',2);
%hold on
%handles.hu = plot(xuv,u,'m-');
%handles.hv = plot(xuv,v,'b-');
%hold off
%legend('H','U','V')

axis([xh(1), xh(end), -1.0, 1.0]);
ylabel('H');
set(gca,'TickDir','out');
set(gca,'XTickLabel','');
set(gca,'Box','on');


% display contour lines
handles.hax2 = axes('Position',[pos(1), pos(2),pos(3),pos(4)*0.48]);
set(handles.hax2,'NextPlot','replacechildren');

handles.hsurf = image(xh,tt,ht);
caxis([-1,1]/2);
set(handles.hsurf,'CDataMapping','scaled');
grid off;
axis([xh(1), xh(end), tt(1), tt(end), -1.0, 1.0]);
set(gca,'Box','on');
set(gca,'TickDir','out');
set(gca,'YDir','default');
view(0,90);
xlabel('X');
ylabel('TIME');

% title
axes(handles.hax1);
cmt = sprintf('Time= %5.1f', t);    % cast time to string
handles.ht = title(cmt);

drawnow;
return;
%----------------------------------------------------

