%------------------ graphic output ------------------
function graph2(xh,h,xu,u,v,ii,t)
  global dt itmax nmax hmax
  global hplot hax1 hq; % static var

  hmax = 0.5;
  hax1;
  if isempty(hax1)
  	hq = [];
    initgraph;
    pos = get(gca,'Position');
    hax1 = axes('Position',pos);
    hplot = plot3(xh,zeros(size(h)),h,'k-');

    grid on
    xlabel('X');
    ylabel('Y');
    zlabel('H');
    axis([xh(1), xh(end), -xh(end)/2, xh(end)/2, 0, hmax]);

    view(30,30)
  else
    
    set(hplot,'zdata',h);
    cmt = sprintf('TIME = %5.1f', t);    % cast time to string
    title(cmt);
  end

	if hq
  delete(hq)
  end
  hold on;
  yy = zeros(size(xu));
  zz = zeros(size(xu));
  dummy = zeros(size(xu));
  %coneplot(xu,yy,zz,u',dummy,v','nointerp')
  idx = 1:5:length(u);
  hq = quiver3(xu(idx),yy(idx),zz(idx),u(idx)',v(idx)',dummy(idx),4,'r-');
  %hq = quiver3(xu(idx),yy(idx),zz(idx),dummy(idx),v(idx)',dummy(idx),4,'r-');
  hold off;
  
  pause(0.05);
return;
%----------------------------------------------------


% ----- initialize graphics -----
function initgraph
  set(gcf,'DoubleBuffer','on');

  % Erase axes in figure, unless the UserData exists (for GUI).
  hh = get(gcf,'Children');
  for l = 1:length(hh)
    if strcmp(get(hh(l),'Type') ,'axes')
      if isempty(get(hh(l),'UserData'))
        delete(hh(l));
      end
    end
  end
  set(gca,'Visible','off');
