%------------------ graphic output ------------------
function handles = gr3(xh,h,xuv,u,v,ii,t,handles)
  global dt itmax nmax hmax
  global hplot hax1 hq1 hq2; % static var

  %initgraph;

  if t == 0
    handles.fig = gcf;
    view(18,20);
  end  
  [az,el] = view;
  
  handles.ax1 = gca;
  
  hh = repmat(h,1,6);
  handles.surf = surf(xh,0:20:100,hh'); %%%%
  caxis([-1,1])

  hold on
  %  hplot1 = plot3(xh,zeros(size(h)),h,'w-','LineWidth',2);
  plot3(xh,zeros(size(h)),h,'k-');
  plot3(xh,ones(size(h))*20,h,'k-');
  plot3(xh,ones(size(h))*40,h,'k-');
  plot3(xh,ones(size(h))*60,h,'k-');
  plot3(xh,ones(size(h))*80,h,'k-');
  plot3(xh,ones(size(h))*100,h,'k-');
  hold off

  shading flat
  hidden off
  alpha(0.55); %%%%
  grid on
  xlabel('X');
  ylabel('Y');
  zlabel('H');
  daspect([100,100,2])
  
  uu = repmat(u',[11,1,11]);
  vv = repmat(v',[11,1,11]);
  ww = ones(size(uu))*0.1;
  ww = zeros(size(uu));
  xrange = xuv;
  yrange = 0:10:100;
  zrange = 0:10:100;
  [x,y,z] = meshgrid(xrange,yrange,zrange);
  
  cxrange = xuv(1):10:xuv(end);
  cyrange = 0:20:100;
  czrange = 0;
  [cx,cy,cz] = meshgrid(cxrange,cyrange,czrange);

  hold on
  plot3(cx,cy,cz,'k.')
  hcone = coneplot(x,y,z,uu,vv,ww,cx,cy,cz,2);
  set(hcone,'FaceColor','red','EdgeColor','none')
  hold off

  box on
  axis([xh(1), xh(end), 0, 100, -1, 1]);
  lightangle(90,45)
  lighting phong;
  
  title(sprintf('T= %3.3f', t))

  rotate3d on
  [az1,el1] = view;
  view(az,el)
  drawnow
return;
%----------------------------------------------------


% ----- initialize graphics -----
function initgraph
  set(gcf,'DoubleBuffer','on');

  % Erase axes in figure, unless the UserData exists (for GUI).
  hh = get(gcf,'Children');
  for l = 1:length(hh)
    if strcmp(get(hh(l),'Type') ,'axes')
      if isempty(get(hh(l),'UserData'))
        delete(hh(l));
      end
    end
  end
  set(gca,'Visible','off');

