function handles = m3grph(t,z, hgr)
  global im jm cmax cmin
  persistent fig

  g=p2s2ga(jm,im,z);
  gt=g';
  gt(im+1,:)=gt(1,:);
  gt(:,jm+1)=gt(:,1);

  stitle=sprintf('T=%4.2f',t);
  
  x=(0:im)/im;
  y=(0:jm)/jm;  

  if exist('OCTAVE_VERSION') == 0
     % matlab
     if t == 0
       fig = gcf;
     end
     handles.fig = fig;

     colormap(jet(256))
     himg = image(x,y,gt');
     shading interp
     set(himg,'CDataMapping','scaled')
     caxis([cmin, cmax]);

     %colorbar
     set(gca,'YDir','default');
     set(gca,'TickDir','out');

     axis equal
     axis([x(1),x(im+1),y(1),y(jm+1)])

     xlabel('X')
     ylabel('Y')
     title(stitle);

     set(gcf,'DoubleBuffer','on')
     set(gca,'NextPlot','replacechildren');
     drawnow;
   else
     % octave
     title(stitle);
     contour(x,y,gt,11); % octave 2.1
%     contour(gt,11,x,y); % octave 2.0
     handles.fig = 0;
   end

return;
