function varargout = inert1_ui(varargin)
% INERT1_UI Application M-file for inert1_ui.fig
%    FIG = INERT1_UI launch inert1_ui GUI.
%    INERT1_UI('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.5 11-Dec-2005 03:40:57

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');
    changeuicolor(fig)

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
    set_figstate('idle', handles);
    
    % STARTUP code ----
    [param.phi, param.x0, param.y0, param.u0, param.v0, param.label] = textread('expar1.data','%f%f%f%f%f%q%*[^\n]', 'commentstyle','matlab');
    set(handles.popup_sample,'String',param.label);
    
    handles.param = param;
  
    setparam(handles,1);
    % STARTUP code ----

	guidata(fig, handles);

	if nargout > 0
		varargout{1} = fig;
	end

else
  if ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		if (nargout)
			[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
		else
			feval(varargin{:}); % FEVAL switchyard
		end
	catch
		disp(lasterr);
	end
  end
  return;
end


init_graphics(handles); % initial
return

%
function init_graphics(handles)

% If the program is running or pausing or trying to stop calculation
ud = get(gcf, 'UserData');
if ~strcmp(ud, 'idle')
  return
end

h = handles.edit7;
oldvalue =get(h,'String');
set(h,'String',0);
start_Callback([], [], handles)
set(h,'String',oldvalue);

return;

%

function setparam(handles,n)
  set(handles.edit1,'String',handles.param.phi(n));
  set(handles.edit2,'String',handles.param.x0(n));
  set(handles.edit3,'String',handles.param.y0(n));
  set(handles.edit4,'String',handles.param.u0(n));
  set(handles.edit5,'String',handles.param.v0(n));
return;


% --------------------------------------------------------------------
function varargout = popup_sample_Callback(h, eventdata, handles, varargin)

n = get(h,'Value');
setparam(handles,n);
init_graphics(handles)

return;


% --------------------------------------------------------------------
function varargout = edit_Callback(h, eventdata, handles, varargin)
init_graphics(handles); % initial


% --------------------------------------------------------------------
% --------------------------------------------------------------------
% --------------------------------------------------------------------
function set_figstate(newstate, handles)
set(gcf, 'UserData', newstate);
ud = get(gcf, 'UserData');
switch ud
    case 'idle' % ready to change parameters, start calculation or exit
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [1.0 1.0 1.0]);
        set(handles.start, 'String', '[> START');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'off');
        set(handles.exit, 'Enable', 'on');
    case 'run' % executing calculation
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'popupmenu'), 'Enable', 'off');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'Enable', 'inactive');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [0.8 0.8 0.8]);
        set(handles.start, 'String', '{}{} PAUSE');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'on');
        set(handles.exit, 'Enable', 'off');
    case 'pause' % uiwait (waiting for uiresume)
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'popupmenu'), 'Enable', 'off');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'Enable', 'inactive');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [0.8 0.8 0.8]);
        set(handles.start, 'String', '[>RESUME');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'on');
        set(handles.exit, 'Enable', 'off');
    case 'stop' % trying to stop calculation
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'off');
    case 'exit' % trying to exit
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'off');
    otherwise
        herr = errordlg(['Error: unknown FIGSTATE = [' ud ']']);
        uiwait(herr);
end
return;

% --------------------------------------------------------------------
function start_Callback(hObject, eventdata, handles)
ud = get(gcf, 'UserData');
switch ud
    case 'idle' % --> START
        set_figstate('run', handles);
        %
        phi = str2double(get(handles.edit1,'String'));
        x0 = str2double(get(handles.edit2,'String'));
        y0 = str2double(get(handles.edit3,'String'));
        u0 = str2double(get(handles.edit4,'String'));
        v0 = str2double(get(handles.edit5,'String'));
        dt = str2double(get(handles.edit6,'String'));
        nmax = str2double(get(handles.edit7,'String'));
        %
        inert1(phi,x0,y0,u0,v0,dt,nmax);
        %
        ud = get(gcf, 'UserData');
        if strcmp(ud, 'exit')
            delete(gcf);
            return;
        end
        set_figstate('idle', handles);
    case 'run' % --> PAUSE
        set_figstate('pause', handles);
        uiwait(gcf);
    case 'pause' % --> RESUME
        set_figstate('run', handles);
        uiresume(gcf);
    case 'stop' % --> do nothing
        return;
    case 'exit' % --> do nothing
        return;
    otherwise
        herr = errordlg(['Error: unknown FIGSTATE = [' ud ']']);
        uiwait(herr);
end
return;

% --------------------------------------------------------------------
function stop_Callback(hObject, eventdata, handles)
%set(gcf, 'Name', 'Linear Advection and Diffusion - Please wait for stopping...');
set_figstate('stop', handles);
uiresume(gcf);
return;

% --------------------------------------------------------------------
function exit_Callback(hObject, eventdata, handles)
ud = get(gcf, 'UserData');
if strcmp(ud, 'idle')
    delete(gcf);
    return;
else
    set_figstate('exit', handles);
    uiresume(gcf);
end
return;
