function varargout = inert2_ui(varargin)
% INERT2_UI Application M-file for inert2_ui.fig
%    FIG = INERT2_UI launch inert2_ui GUI.
%    INERT2_UI('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.5 11-Dec-2005 04:04:43

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');
	%set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));
    changeuicolor(fig)

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
    set_figstate('idle', handles);

    % STARTUP code ----
    [param.phi, param.p1, param.q1,param.p2, param.q2,param.p3, param.q3, param.dy, param.label] = textread('expar2.data','%f%f%f%f%f%f%f%f%q%*[^\n]', 'commentstyle','matlab');
    set(handles.popup_sample,'String',param.label);
    
    handles.param = param;
  
    setparam(handles,1);
    % STARTUP code ----
    
    guidata(fig, handles);

	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		if (nargout)
			[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
		else
			feval(varargin{:}); % FEVAL switchyard
		end
	catch
		disp(lasterr);
	end

end


function setparam(handles,n)
  set(handles.edit1,'String',handles.param.phi(n));
  set(handles.edit2,'String',handles.param.p1(n));
  set(handles.edit3,'String',handles.param.q1(n));
  set(handles.edit4,'String',handles.param.p2(n));
  set(handles.edit5,'String',handles.param.q2(n));
  set(handles.edit6,'String',handles.param.p3(n));
  set(handles.edit7,'String',handles.param.q3(n));
  set(handles.edit8,'String',handles.param.dy(n));
return;


% --------------------------------------------------------------------
function varargout = popup_sample_Callback(h, eventdata, handles, varargin)

n = get(h,'Value');
setparam(handles,n);

return;

% --------------------------------------------------------------------
function varargout = popupmenu3_Callback(h, eventdata, handles, varargin)

% --------------------------------------------------------------------
function varargout = edit17_Callback(h, eventdata, handles, varargin)

% --------------------------------------------------------------------
function varargout = edit18_Callback(h, eventdata, handles, varargin)

% --------------------------------------------------------------------
function varargout = edit19_Callback(h, eventdata, handles, varargin)

% --------------------------------------------------------------------
function varargout = edit20_Callback(h, eventdata, handles, varargin)

% --------------------------------------------------------------------
function varargout = edit21_Callback(h, eventdata, handles, varargin)

% --------------------------------------------------------------------
function varargout = edit22_Callback(h, eventdata, handles, varargin)

% --------------------------------------------------------------------
function varargout = edit23_Callback(h, eventdata, handles, varargin)

% --------------------------------------------------------------------
function varargout = edit24_Callback(h, eventdata, handles, varargin)

% --------------------------------------------------------------------
function varargout = edit25_Callback(h, eventdata, handles, varargin)

% --------------------------------------------------------------------
function varargout = edit26_Callback(h, eventdata, handles, varargin)


% --------------------------------------------------------------------
% --------------------------------------------------------------------
% --------------------------------------------------------------------
function set_figstate(newstate, handles)
set(gcf, 'UserData', newstate);
ud = get(gcf, 'UserData');
switch ud
    case 'idle' % ready to change parameters, start calculation or exit
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [1.0 1.0 1.0]);
        set(handles.start, 'String', '[> START');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'off');
        set(handles.exit, 'Enable', 'on');
    case 'run' % executing calculation
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'popupmenu'), 'Enable', 'off');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'Enable', 'inactive');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [0.8 0.8 0.8]);
        set(handles.start, 'String', '{}{} PAUSE');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'on');
        set(handles.exit, 'Enable', 'off');
    case 'pause' % uiwait (waiting for uiresume)
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'popupmenu'), 'Enable', 'off');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'Enable', 'inactive');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [0.8 0.8 0.8]);
        set(handles.start, 'String', '[>RESUME');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'on');
        set(handles.exit, 'Enable', 'off');
    case 'stop' % trying to stop calculation
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'off');
    case 'exit' % trying to exit
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'off');
    otherwise
        herr = errordlg(['Error: unknown FIGSTATE = [' ud ']']);
        uiwait(herr);
end
return;

% --------------------------------------------------------------------
function start_Callback(hObject, eventdata, handles)
ud = get(gcf, 'UserData');
switch ud
    case 'idle' % --> START
        set_figstate('run', handles);
        %
        phi = str2double(get(handles.edit1,'String'));
        p1 = str2double(get(handles.edit2,'String'));
        q1 = str2double(get(handles.edit3,'String'));
        p2 = str2double(get(handles.edit4,'String'));
        q2 = str2double(get(handles.edit5,'String'));
        p3 = str2double(get(handles.edit6,'String'));
        q3 = str2double(get(handles.edit7,'String'));
        dy = str2double(get(handles.edit8,'String'));
        dt = str2double(get(handles.edit9,'String'));
        nmax = str2double(get(handles.edit10,'String'));
        %
        inert2(phi,p1,q1,p2,q2,p3,q3,dy,dt,nmax);
        %
        ud = get(gcf, 'UserData');
        if strcmp(ud, 'exit')
            delete(gcf);
            return;
        end
        set_figstate('idle', handles);
    case 'run' % --> PAUSE
        set_figstate('pause', handles);
        uiwait(gcf);
    case 'pause' % --> RESUME
        set_figstate('run', handles);
        uiresume(gcf);
    case 'stop' % --> do nothing
        return;
    case 'exit' % --> do nothing
        return;
    otherwise
        herr = errordlg(['Error: unknown FIGSTATE = [' ud ']']);
        uiwait(herr);
end
return;

% --------------------------------------------------------------------
function stop_Callback(hObject, eventdata, handles)
%set(gcf, 'Name', 'Linear Advection and Diffusion - Please wait for stopping...');
set_figstate('stop', handles);
uiresume(gcf);
return;

% --------------------------------------------------------------------
function exit_Callback(hObject, eventdata, handles)
ud = get(gcf, 'UserData');
if strcmp(ud, 'idle')
    delete(gcf);
    return;
else
    set_figstate('exit', handles);
    uiresume(gcf);
end
return;
