%***********************************************************************
% TITLE
%   Geophysical Fluid Dynamics - Computer Exercises -
%
%   1-D Advection and Diffusion:
%   Burgers equation
%
% HISTORY
%   1999/05/06 Seiya Nishizawa
%   1999/05/12 Shigeo Yoden
%   2004/05/24 Koichi Shin (RISH) (convert to the MATLAB code)
%***********************************************************************
function du = fcn(kmax, t, u, du)

global dx rnu;

imax=200;          % imax: number of grid  % imax: number of grid

%real u(0:imax),du(0:imax)
%real uu(0:imax)              % uu(i)=u(i+1/2)
%real ff(0:imax)              % ff(i)=f(i+1/2)

du = zeros(size(u));
uu = zeros(size(u));
ff = zeros(size(u));

%**********************
% uu
uu(0+1) = u(0+1) ...
          -(u(2+1) -u(1+1)* 8 +u(imax-1+1)* 8 -u(imax-2+1)           )/24 ...
          -(u(2+1) -u(1+1)*16 -u(imax-1+1)*16 +u(imax-2+1) +u(0+1)*30)/96 ...
          +(u(2+1) -u(1+1)* 2 +u(imax-1+1)* 2 -u(imax-2+1)           )/96 ...
          +(u(2+1) -u(1+1)* 4 -u(imax-1+1)* 4 +u(imax-2+1) +u(0+1)* 6)/384;
uu(1+1) = u(1+1) ...
          -(u(3+1) -u(2+1)* 8 +u(0+1)* 8 -u(imax-1+1)           )/24 ...
          -(u(3+1) -u(2+1)*16 -u(0+1)*16 +u(imax-1+1) +u(1+1)*30)/96 ...
          +(u(3+1) -u(2+1)* 2 +u(0+1)* 2 -u(imax-1+1)           )/96 ...
          +(u(3+1) -u(2+1)* 4 -u(0+1)* 4 +u(imax-1+1) +u(1+1)* 6)/384;

i=(2+1):(imax-2+1);
uu(i) = u(i) ...
        - (u(i+2) -u(i+1)* 8 +u(i-1)* 8 -u(i-2)         )/24 ...
        - (u(i+2) -u(i+1)*16 -u(i-1)*16 +u(i-2) +u(i)*30)/96 ...
        + (u(i+2) -u(i+1)* 2 +u(i-1)* 2 -u(i-2)         )/96 ...
        + (u(i+2) -u(i+1)* 4 -u(i-1)* 4 +u(i-2) +u(i)* 6)/384;

uu(imax-1+1) = u(imax-1+1) ...
    - (u(1+1) - u(0+1)* 8 + u(imax-2+1)* 8 - u(imax-3+1)        )/24 ...
    - (u(1+1) - u(0+1)*16 - u(imax-2+1)*16 + u(imax-3+1) ...
       + u(imax-1+1)*30)/96 ...
    + (u(1+1) - u(0+1)* 2 + u(imax-2+1)* 2 - u(imax-3+1)        )/96 ...
    + (u(1+1) - u(0+1)* 4 - u(imax-2+1)* 4 + u(imax-3+1) ...
       + u(imax-1+1)* 6)/384;

uu(imax+1) = uu(0+1);

%**********************
% ff
ff(0+1) = 0.5*uu(0+1).^2 + rnu*(uu(2+1) - uu(1+1)*8 + uu(imax-1+1)*8 - uu(imax-2+1))/(12*dx);
ff(1+1) = 0.5*uu(1+1).^2  ...
          + rnu*(uu(3+1) - uu(2+1)*8 + uu(0+1     )*8 - uu(imax-1+1))/(12*dx);

i=(2+1):(imax-2+1);
ff(i) = 0.5*uu(i).^2 + rnu.*(uu(i+2) -uu(i+1)*8 +uu(i-1)*8 -uu(i-2))./(12*dx);

ff(imax-1+1) = 0.5*uu(imax-1+1).^2 ...
    + rnu*(uu(1+1) - uu(0+1)*8 + uu(imax-2+1)*8 - uu(imax-3+1))/(12*dx);
ff(imax+1)=ff(0+1);

%**********************
% du (output)
du(i) = - (ff(i) - ff(i-1)) ./ dx;

du(0+1) = du(imax+1);

return
%*****************************************************************************
