%*-----------------------------------------------------------------------
%*    Runge-Kutta driver (Uniform step)
%*-----------------------------------------------------------------------
%*     Copyright (C) 2000 GFD Dennou Club. All rights reserved.
%*-----------------------------------------------------------------------
%*      2004/05/24 Koichi Shin (RISH) (convert to the MATLAB code)
%*-----------------------------------------------------------------------
function x = odrkdu(n, algr, fcn, t, tend, istep, x, work)

%dimension  x(n), work(n,*)
%                 work(n,2) for rkg, odrk2, odrk1
%                 work(n,4) for odrk4
%external   fcn, algr

if n < 1
  disp('e', 'odrkdu', 'invalid n.')
  return
end

t0 = t;
dt = (tend-t0)/istep;
for j=1:istep
  work(:,1) = feval(fcn, n, t, x, work(:,1) );
  x = feval(algr, n, fcn, t, dt, x, work(:,1), x, work(:,2) );
  t = t0 + dt*j;
end

return
