%*-----------------------------------------------------------------------
%*    Runge-Kutta driver (Uniform step)
%*-----------------------------------------------------------------------
%*     Copyright (C) 2000 GFD Dennou Club. All rights reserved.
%*-----------------------------------------------------------------------
function x = odrkdu(n, algr, fcn, t, tend, istep, x, work)

%      dimension  x(n), work(n,*)
%*                      work(n,2) for rkg, odrk2, odrk1
%*                      work(n,4) for odrk4

      %if n < 1
      %  disp('e', 'odrkdu', 'invalid n.')
      %  return
      %end
      
      work1 = zeros(n,1);
      work2 = zeros(n,1);
      
      t0 = t;
      dt = (tend-t)/istep;

      for jj=1:istep
        work1 = feval(fcn, n, t, x, work1);

        %x = feval(algr, n, fcn, t, dt, x, work1, x, work(:,2) );
        x = feval(algr, n, fcn, t, dt, x, work1, x, work2 );

        t = t0 + dt*jj;
      end

return
