%
% rwave1(beta, sigma, h=0.1, nstep=100, grid=128)
%
%  beta :
%  sigma:
%  h    : dt
%  nstep:
%  grid :
%
% ex.
%  beta = 10;
%  sigma = 0.02;
%
function rwave1(beta, sigma, varargin)
  global im jm
  global cmax cmin

  %beta=10; %
  %sigma=0.02; %
  h=0.01; % dt
  nstep = 100;
  grid = 256;
  
  for k = 1:length(varargin)
    arg = varargin{k};
    if isempty(arg)
      continue
    end
    switch k 
     case 1
      h = arg;
     case 2
      nstep = arg;
     case 3
      grid = arg;
    end
  end  

  im=grid;
  jm=grid;
  %km=63;
  %lm=63;
  km=grid/2;
  lm=grid/2;
  
  i=1:im;
  j=1:jm;
  l=-lm:lm;
  k=-km:km;  
  x=(i-1)/im;
  y=(j-1)/jm;


  %
  wj=ones(jm,1);
  wi=ones(1,im);

  wl=ones(1,1+lm*2);
  wk=ones(1,1+km*2);
  ws=-wl'*(k.*k)-(l.*l)'*wk;
  ws(lm+1,km+1)=1;
  ws=beta*h*(wl'*k)./ws;

  %
  x1=0.5;
  y1=0.5;
  g=exp(-(wj*((x-x1).*(x-x1))+((y-y1).*(y-y1))'*wi)/(2*sigma^2));
  z=p2g2sa(lm,km,g);
  z(1+lm,1+km)=0;

  %
  cmax = sigma*10;
  cmin = -cmax;
  
  %
  t=0;
  handles = m2grph(t,z);
  for istep=1:nstep
    t=t+h;
    z=cos(ws).*z+sin(ws).*z(lm+1-l,km+1-k);
    
    ud = get(gcf, 'UserData');
    if strcmp(ud, 'stop') || strcmp(ud, 'exit')
      return;
    end
    m2grph(t,z);
    drawnow;
  end


