%------------------ graphic output ------------------
function h = gr(p, psi, h)

  cmax = p.cmax;
  cmin = -p.cmax;
  
  if p.p_time == 0
    h.fig = gcf;
    set(gcf,'DoubleBuffer','on')
  end
  
  % ----
  %h.surf = surf(p.x, p.y, psi);
    h.surf = image(p.x, p.y, psi);
    set(h.surf,'CDataMapping','scaled')
    %h.surf = pcolor(p.x, p.y, psi);

    box on
    set(gca,'PlotBoxAspectRatio',[1 0.5 1]);
        
    shading interp;
    %alpha(hsurf,0.9)
    caxis([cmin, cmax])
    axis([ p.xxmin, p.xxmax, p.yymin, p.yymax])

    xlabel('X')
    ylabel('Y')
    zlabel('Z')

    %view(-10,25)
    %view(0,90)
    %colorbar('horiz')
    %colorbar

  msg = sprintf('Rossby wave: Time= %6.1f, Cont.=%g', p.p_time, p.cmax2);
  title(msg)

  % Contour -----
  hold on
  [cs, h.cb] = contour(p.x, p.y, psi, [cmin:p.cmax2:cmax],'k-');
  hold off

  if ~isempty(h.cb)
    %--- change line
    for ii=1:length(h.cb)
      ud = get(h.cb(ii),'UserData');
      if ud < 0
        set(h.cb(ii),'LineStyle','--')
      end
    end
  end  
 
  % Draw page ---
  drawnow
return;

