%------------------ graphic output ------------------
function graphics(p, psi)
  persistent hsurf hcb

  cmax = p.cmax;
  cmin = -p.cmax;
  
  % ----
  if isempty(hsurf)
    hsurf = surf(p.x, p.y, psi);
    %hsurf = pcolor(p.x, p.y, psi);

    box on
    set(gca,'PlotBoxAspectRatio',[1 0.5 1]);
        
    shading interp;
    %alpha(hsurf,0.9)
    caxis([cmin, cmax])
    axis([ p.xxmin, p.xxmax, p.yymin, p.yymax])

    xlabel('X')
    ylabel('Y')
    zlabel('Z')

    %view(-10,25)
    view(0,90)
    %colorbar('horiz')
    colorbar
  else
    set(hsurf,'zdata',psi,'cdata',psi)
  end

  msg = sprintf('Rossby wave / T= %6.1f', p.p_time);
  title(msg)

  % Contour -----
  hold on
  for ii=1:length(hcb)
    delete(hcb(ii)); % erase previous contour line
  end
  [dummy, hcb] = contour3(p.x, p.y, psi, [cmin:cmax/20:cmax],'k-');
  hold off
 
  % Draw page ---
  drawnow
return;

