%------------------------------------------------------
%
%------------------------------------------------------
function p = rossby(beta,nu, imx,jmx, xmax,ymax, dt, itype, amp, w)

  p.beta=beta;
  p.nu=nu;

  %p.imx=64;
  %p.jmx=32;
  %p.xmax = 1.;
  %p.ymax = 0.5;

  p.imx=imx;
  p.im0=p.imx-1;
  p.im1=p.imx+1;

  p.jmx=jmx;
  p.jm0=p.jmx-1;
  p.jm1=p.jmx+1;

  p.xmax = xmax;
  p.xmin = 0;
  p.ymax = ymax;
  p.ymin = 0;

  p.xxmax = p.xmax; 
  p.xxmin = p.xmin;
  p.yymax = p.ymax; 
  p.yymin = p.ymin;
  
  p.cmax = 0.5;
  
  %p.dt = 5.0; % delta time
  p.dt = dt; % delta time

  %------------
  p.p_time=0.;

  p.fac = zeros(p.im0, p.jm0);
  p.zeta = zeros(p.im0, p.jm0);

  
  %------------
  p.dx = p.xmax/p.imx;
  p.dy = p.ymax/p.jmx;

  p.x = p.dx*(0:p.imx);
  p.y = p.dy*(0:p.jmx);

  % factor
  for x=1:p.im0
    xk = pi/p.xmax*x;
    for y=1:p.jm0 
      yl = pi/p.ymax*y;
      p.fac(x,y) = -1.0/(xk^2 + yl^2)/(4.0*p.imx*p.jmx);
    end
  end

  
  % initial value of zeta
  switch itype
   case 1 % sin
    p.cmax = 0.5;
    p.cmax2 = 0.1;
    %p.cmax = p.cmax/w*2;
    %p.cmax = p.cmax/w*2;
    for x=1:p.im0
      xx = w*pi/p.imx*x;
      for y=1:p.jm0
        yy = 2.0*pi/p.jmx*y;
        p.zeta(x,y) = amp.*sin(xx)*sin(yy);
      end
    end
   
   case 2 % gauss
    p.xxmax = 1;
    p.xxmin = 0.6;
    p.yymax = 0.35;
    p.yymin = 0.15;

    %p.xxmax = 1;
    %p.xxmin = 0;
    %p.yymax = 0.5;
    %p.yymin = 0;
    
    p.cmax = 0.003;
    p.cmax2 = 0.0002;
    xnc =fix(p.im0/10*8)+1;
    ync =fix(p.jm0/2)+1;
    nw = fix(p.im0/10);

    [xx, yy] = meshgrid((-nw):nw,(-nw):nw);
    p.zeta(((xnc-nw):(xnc+nw)),((ync-nw):(ync+nw))) = -amp.*exp( -(xx.^2+yy.^2)./((w/100)^2));
  
    %p.cmax = max(max(p.zeta))
   
   otherwise
    error('itype')
  end

  %------------
  %p = class(p,'rossby');

return;
