%-----------------------------------------------------
%   Linear vorticity Eq.
%-----------------------------------------------------

%------------- Runge-Kutta ------------
function p = runge_kutta(p)
  dz1 = drv(p, p.zeta        );
  dz2 = drv(p, p.zeta+dz1/2.0);
  dz3 = drv(p, p.zeta+dz2/2.0);
  dz4 = drv(p, p.zeta+dz3    );
     
  p.zeta = p.zeta +(dz1 +2*dz2 +2*dz3 +dz4) /6.0;

  p.p_time = p.p_time + p.dt;

return;

%------------- Vorticity Eq. ------------
function dz = drv(p, zz)

  %fac = get(p,'Factor');
  psi = poisson(p.fac, zz);
  
  dz = p.dt * ( -p.beta *d_x( psi(:,2:p.jmx), p.dx) );

return;

%--------------- derivative_x ------------------
function ret = d_x(var, dx)
  [m,n] = size(var);
  %ret = zeros(m-2, n);

  ret = (var(3:m,:)-var(1:(m-2),:))/(2*dx) ;
return;

