% rwave2 Rossby Wave
% 
% rwave2(beta, nu)
%     beta
%
%
%
function rwave2(beta, itype, amp, w, dt, gridsize, itmax)
  %beta=1.0;
  nu=0.0;

  %itmax = 200;

  imx=gridsize;
  jmx=gridsize/2;
  xmax = 1.0;
  ymax = 0.5;
  
  %dt = 5.0;
  %amp = 1.0;
  %w =5;
  
  p = rossby(beta, nu, imx, jmx, xmax, ymax, dt, itype,amp,w);

  % initialize graphics
  h.fig = gcf;
  %set(gcf,'UserData',1);
  set(gcf,'BackingStore','off');
  colormap(jet(256));

  % display initial values
  ppsi = poisson(p.fac, p.zeta);
  h = gr(p, ppsi', h);

  % ---- time integration ----
  for ii=1:itmax
    drawnow;

    %for jj=1:2
      p = runge_kutta(p);
    %end

    ud = get(gcf, 'UserData');
    if strcmp(ud, 'stop') || strcmp(ud, 'exit')
        return;
    end

    drawnow;
    
    % display
    ppsi = poisson(p.fac, p.zeta);
    h = gr(p, ppsi',h);
  end

return;
