%
%
%
function tdvort1(itype, varargin)
  global im jm dl cmax cmin

  itype;
  varargin;
  km=21;
  lm=21;

  grid = 128;

  %itype = 1;
  
  nstep=100; %
  h=1; %
  m=1; %
  nv=5; % order of Laplacian of high-order viscosity term
  dnu=1e-13; % high-order viscosity
  deltat=h/m; % time grid size for runge-kutta

  %**********
  % 
  switch itype
    case 1
     a1 = varargin{1};
     b1 = varargin{2};
     c1 = varargin{3};
     a2 = varargin{4};
     b2 = varargin{5};
     c2 = varargin{6};
     for k = 1:length(varargin)  
       switch k 
        case 7
         deltat = varargin{k};
         h = deltat*m;
        case 8
         nstep = varargin{k};
        case 9
         grid = varargin{k};
       end
     end
   
   case 2
     a1 = varargin{1};
     b1 = varargin{2};
     c1 = varargin{3};
     for k = 1:length(varargin)  
       switch k 
        case 4
         deltat = varargin{k};
         h = deltat*m;
        case 5
         nstep = varargin{k};
        case 6
         grid = varargin{k};
       end
     end
   
   otherwise
    disp('itype error');
    return;
  end
  
  im=grid;
  jm=grid;

  k=-km:km;
  l=-lm:lm;
  wk=ones(1,1+2*km);
  wl=ones(1+2*lm,1);
  dl=exp(-dnu*deltat/2*(((l.*l)'*wk+wl*(k.*k)).^(nv*(wl*wk))));

  i=1:im;
  j=1:jm;
  x=(i-1)/im;
  y=(j-1)/jm;
  wj=ones(jm,1);
  wi=ones(1,im);

  % initial form
  switch itype
   case 1   % twin vortices
    % give volticity distribution composed of two Gaussian vortices on grid points
    va1 = a1;va2 = a2;
    x1=b1;y1=0.5;
    x2=b2;y2=0.5;
    sigma1=c1;sigma2=c2;
    %va1 = 1.0;va2 = 1.0;
    %x1=0.4;y1=0.4;x2=0.6;y2=0.6;sigma1=0.05;sigma2=0.05;
    
    g= va1*exp(-(wj*((x-x1).*(x-x1))+((y-y1).*(y-y1))'*wi)/(2*sigma1^2))...
       +va2*exp(-(wj*((x-x2).*(x-x2))+((y-y2).*(y-y2))'*wi)/(2*sigma2^2));
   
   case 2   % elliptic vortex
    % give volticity distribution composed of elliptic vortex (Gaussian distribution in x- and y-directions) on grid points
    %va = 0.75; sigmax = 0.2; sigmay = 0.05;
    va = a1; sigmax = b1; sigmay = c1;

    g = va*(exp(-(wj*((x-0.5).^2))/(2*sigmax^2))) ...
        .*(exp(-(((y-0.5).^2)'*wi)/(2*sigmay^2)));

   otherwise
    disp('input parameter error')
    return;
  end

  cmax = max(max(g));
  cmin = min(min(g));
  
  z=p2g2sa(lm,km,g);
  z(1+lm,1+km)=0;

  t=0;
  m1grph(t,z,gca);

  for istep=1:nstep
    ud = get(gcf, 'UserData');
    if strcmp(ud, 'stop') || strcmp(ud, 'exit')
      return;
    end

    [t,z]=tdrknu(m,h,t,z,'m1funl','m1funn');

    if min(isfinite(z))==0
      disp('Overflow')
      return
    end

    m1grph(t,z, gca);
  end
