function varargout = tdvort1_ui(varargin)
% Last Modified by GUIDE v2.5 15-Dec-2005 00:12:06

if nargin == 0  % LAUNCH GUI

  fig = openfig(mfilename,'reuse');
  %set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));
  %changeuicolor(fig)

  % Generate a structure of handles to pass to callbacks, and store it. 
  handles = guihandles(fig);

  % STARTUP code ----
  set(gcf, 'HandleVisibility', 'on');
  set(gcf, 'CloseRequestFcn', 'tdvort1_ui(''exit_Callback'',gcf,[],guidata(gcf))');
  
  param = [];
  % for ELLIPTIC VORTEX (param.itype = 2)
  paramfile = 'expar12.data';
  try
    [param.a3, param.b3, param.c3, ...
     param.dt, param.nstep, param.grid, ...
     param.label2] = textread(paramfile,'%f%f%f%f%f%f%q%*[^\n]', 'commentstyle','matlab');
    set(handles.popup_sample,'String',param.label2);
  catch
    herr = errordlg(['Cant read a example parameters file: ', ...
                     paramfile,'.'],'Error');
    uiwait(herr)
  end

  % for TWO CIRCULAR VORTICES (param.itype = 1)
  paramfile = 'expar11.data';
  try
    [param.a1, param.b1, param.c1, ...
     param.a2, param.b2, param.c2, ...
     param.dt, param.nstep, param.grid, ...
     param.label1] = textread(paramfile,'%f%f%f%f%f%f%f%f%f%q%*[^\n]', 'commentstyle','matlab');
  catch
    herr = errordlg(['Cant read a example parameters file: ', ...
                     paramfile,'.'],'Error');
    uiwait(herr)
  end

  set(handles.radiobutton1, 'Value', 0);
  set(handles.radiobutton2, 'Value', 1);
  param.itype = 2;
  
  handles.param = param;
  setparam(handles,1);

  set_figstate('idle', handles);
  % STARTUP code ----
  
  guidata(fig, handles);

  if nargout > 0
    varargout{1} = fig;
  end

else
  if ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK
    try
      if (nargout)
        [varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
      else
        feval(varargin{:}); % FEVAL switchyard
      end
    catch
      disp(lasterr);
    end
  end
  return
end


init_graphics(handles)
return

% --------------------------------------------------------------------
% invoked to show initial values
function init_graphics(handles)

% If the program is running or pausing or trying to stop calculation
ud = get(gcf, 'UserData');
if ~strcmp(ud, 'idle')
  return
end

% To show initial state, call the calculation and drawing routines with
% nstep = 0.
nstep =get(handles.edit10,'String');
set(handles.edit10,'String',0);
start_Callback([], [], handles)
set(handles.edit10,'String',nstep);

return;


% --------------------------------------------------------------------
% get values from EDIT BOXES
function p = getparams(handles)

p.err = 0;

% get values from EDIT BOXES
if get(handles.radiobutton1,'Value')
  p.itype = 1;
else
  p.itype = 2;
end

p.a1 = str2double(get(handles.edit1,'String'));
p.b1 = str2double(get(handles.edit2,'String'));
p.c1 = str2double(get(handles.edit3,'String'));
p.a2 = str2double(get(handles.edit5,'String'));
p.b2 = str2double(get(handles.edit6,'String'));
p.c2 = str2double(get(handles.edit7,'String'));

p.dt = str2double(get(handles.edit9,'String'));
p.nstep = str2double(get(handles.edit10,'String'));
p.grid = str2double(get(handles.edit13,'String'));

% If a parameter is not numerical, return after showing an error message.
if isnan(p.a1) | isnan(p.b1) | isnan(p.c1)
  errordlg('Input parameters must be numerical characters.');
  p.err = 1;
end

return


% --------------------------------------------------------------------
function setparam(handles,n)

if ~isempty(handles.param)
%handles.param
  switch handles.param.itype
    case 1
     set(handles.edit1,'String',handles.param.a1(n));
     set(handles.edit2,'String',handles.param.b1(n));
     set(handles.edit3,'String',handles.param.c1(n));
     set(handles.edit5,'String',handles.param.a2(n));
     set(handles.edit6,'String',handles.param.b2(n));
     set(handles.edit7,'String',handles.param.c2(n));
     set(handles.edit9,'String',handles.param.dt(n));
     set(handles.edit10,'String',handles.param.nstep(n));
     set(handles.edit13,'String',handles.param.grid(n));
   case 2
     set(handles.edit1,'String',handles.param.a3(n));
     set(handles.edit2,'String',handles.param.b3(n));
     set(handles.edit3,'String',handles.param.c3(n));
     set(handles.edit5,'String','');
     set(handles.edit6,'String','');
     set(handles.edit7,'String','');
     set(handles.edit9,'String',handles.param.dt(n));
     set(handles.edit10,'String',handles.param.nstep(n));
     set(handles.edit13,'String',handles.param.grid(n));
  end
end
return;


% --------------------------------------------------------------------
function varargout = popup_sample_Callback(h, eventdata, handles, varargin)

n = get(h,'Value');
setparam(handles,n);
init_graphics(handles)

return;


% --------------------------------------------------------------------
function varargout = edit_Callback(h, eventdata, handles, varargin)
init_graphics(handles)
return


% --------------------------------------------------------------------
function varargout = radiobutton1_Callback(h, eventdata, handles, varargin)

if ~get(h,'Value')
  set(h,'value',1);
  return
end

set(handles.radiobutton2,'Value',0);
set(handles.text1,'String','VA');
set(handles.text2,'String','X');
set(handles.text3,'String','VS');

set(handles.edit5,'Enable','on');
set(handles.edit6,'Enable','on');
set(handles.edit7,'Enable','on');

handles.param.itype = 1;
guidata(gcf, handles);

set(handles.popup_sample,'Value',1);
set(handles.popup_sample,'String',handles.param.label1);
setparam(handles,1);
init_graphics(handles)
set_figstate('idle', handles);

return;


% --------------------------------------------------------------------
function varargout = radiobutton2_Callback(h, eventdata, handles, varargin)

if ~get(h,'Value')
  set(h,'value',1);
  return
end

set(handles.radiobutton1,'Value',0);
set(handles.text1,'String','VA');
set(handles.text2,'String','VSX');
set(handles.text3,'String','VSY');

set(handles.edit5,'Enable','off');
set(handles.edit6,'Enable','off');
set(handles.edit7,'Enable','off');

handles.param;
handles.param.itype = 2;
guidata(gcf, handles);

set(handles.popup_sample,'Value',1);
set(handles.popup_sample,'String',handles.param.label2);
setparam(handles,1);
init_graphics(handles)
set_figstate('idle', handles);

return


% --------------------------------------------------------------------
% --------------------------------------------------------------------
% --------------------------------------------------------------------
function set_figstate(newstate, handles)
set(gcf, 'UserData', newstate);
ud = get(gcf, 'UserData');
switch ud
    case 'idle' % ready to change parameters, start calculation or exit
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [1.0 1.0 1.0]);
        set(handles.start, 'String', '[> START');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'off');
        set(handles.exit, 'Enable', 'on');
        if handles.param.itype == 2
            set(handles.edit5, 'Enable', 'off');
            set(handles.edit6, 'Enable', 'off');
            set(handles.edit7, 'Enable', 'off');
            set(handles.edit5, 'BackgroundColor', [0.8 0.8 0.8]);
            set(handles.edit6, 'BackgroundColor', [0.8 0.8 0.8]);
            set(handles.edit7, 'BackgroundColor', [0.8 0.8 0.8]);
        end
    case 'run' % executing calculation
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'popupmenu'), 'Enable', 'off');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'Enable', 'inactive');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [0.8 0.8 0.8]);
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'radiobutton', 'Value', 0.0), 'Enable', 'off');
        set(handles.start, 'String', '{}{} PAUSE');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'on');
        set(handles.exit, 'Enable', 'off');
    case 'pause' % uiwait (waiting for uiresume)
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'on');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'popupmenu'), 'Enable', 'off');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'Enable', 'inactive');
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'edit'), 'BackgroundColor', [0.8 0.8 0.8]);
        set(findobj(gcf, 'Type', 'uicontrol', 'Style', 'radiobutton', 'Value', 0.0), 'Enable', 'off');
        set(handles.start, 'String', '[>RESUME');
        set(handles.start, 'Enable', 'on');
        set(handles.stop, 'Enable', 'on');
        set(handles.exit, 'Enable', 'off');
    case 'stop' % trying to stop calculation
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'off');
    case 'exit' % trying to exit
        set(findobj(gcf, 'Type', 'uicontrol'), 'Enable', 'off');
    otherwise
        herr = errordlg(['Error: unknown FIGSTATE = [' ud ']']);
        uiwait(herr);
end
return;

% --------------------------------------------------------------------
function start_Callback(hObject, eventdata, handles)
ud = get(gcf, 'UserData');
switch ud
    case 'idle' % --> START
        set_figstate('run', handles);
        p = getparams(handles); % load parameters set in GUI
        if p.err
          return;
        end
        %
        switch p.itype
         case 1
          tdvort1(p.itype, p.a1,p.b1,p.c1, p.a2,p.b2,p.c2, p.dt, p.nstep,p.grid);
         case 2
          tdvort1(p.itype, p.a1,p.b1,p.c1, p.dt, p.nstep,p.grid);
        end
        %
        ud = get(gcf, 'UserData');
        if strcmp(ud, 'exit')
            delete(gcf);
            return;
        end
        set_figstate('idle', handles);
    case 'run' % --> PAUSE
        set_figstate('pause', handles);
        uiwait(gcf);
    case 'pause' % --> RESUME
        set_figstate('run', handles);
        uiresume(gcf);
    case 'stop' % --> do nothing
        return;
    case 'exit' % --> do nothing
        return;
    otherwise
        herr = errordlg(['Error: unknown FIGSTATE = [' ud ']']);
        uiwait(herr);
end
return;

% --------------------------------------------------------------------
function stop_Callback(hObject, eventdata, handles)
%set(gcf, 'Name', 'Linear Advection and Diffusion - Please wait for stopping...');
set_figstate('stop', handles);
uiresume(gcf);
return;

% --------------------------------------------------------------------
function exit_Callback(hObject, eventdata, handles)
ud = get(gcf, 'UserData');
if strcmp(ud, 'idle')
    delete(gcf);
    return;
else
    set_figstate('exit', handles);
    uiresume(gcf);
end
return;



% --------------------------------------------------------------------
function edit1_Callback(hObject, eventdata, handles)
function edit2_Callback(hObject, eventdata, handles)
function edit3_Callback(hObject, eventdata, handles)
function edit5_Callback(hObject, eventdata, handles)
function edit6_Callback(hObject, eventdata, handles)
function edit7_Callback(hObject, eventdata, handles)
function edit9_Callback(hObject, eventdata, handles)
function edit10_Callback(hObject, eventdata, handles)
function edit13_Callback(hObject, eventdata, handles)
