%
% Instability of elliptic vortex
%
% lambda
% nstep
% im
% 
function tdvort21(varargin)
  global im dq

  im=256; % number of equinoxes. Reduce it to save calculation time.

  nstep=100; %
  h=0.2;     %
  m=1;       %
  
  lambda=4; % aspect ratio of elliptic vortex (If larger than 3, instable.)

  %
  for k = 1:length(varargin)  
    var = varargin{k};
    if isempty(var)
      continue
    end
    switch k
     case 1
      lambda = var;
     case 2
      h = var;
     case 3
      nstep = var;
     case 4
      im = var;
    end
  end

  km=im/2-1;
  %
  k=1:km;
  k2=-km:km;
  kw=[im-km+k-1,0:km];
  z=zeros(2*km+1,1);

  zi=sqrt(-1);

  i=(1:im)';  
  zi=sqrt(-1);
  g=cos(2*pi*(i-1)/im)+zi*sin(2*pi*(i-1)/im)/lambda;

  g(1)=g(1)+1e-4; % infinitesimal perturbation on a node

  w=fft(g)/im;
  z(1+km+k2,1)=w(1+kw);  
  
  dq=2*pi; % jump of vorticity across contour line
  
  fm=2; % size of frame for drawing
  
  t=0;
  z=c2rdst(z);
  handles = c2grph(t,z,fm);
  for istep=1:nstep
    ud = get(gcf, 'UserData');
    if strcmp(ud, 'stop') || strcmp(ud, 'exit')
      return;
    end
    [t,z]=tdrk4u(m,h,t,z,'c2fun');
    drawnow;
    z=c2rdst(z);
    drawnow;
    handles = c2grph(t,z,fm);
  end

