% Fusion of twin vortices
%
%
%
function tdvort3(varargin)
  global im dq
  
  im=512;
  nstep=1000;
  h=0.25;
  m=1;

  x1 = 1.6;
  r1 = 1;
  x2 = -1.6;
  r2 = 1;
  
  dq(1)=2*pi; % vorticity of vortex 1
  dq(2)=2*pi; % vorticity of vortex 2

  %
  for k = 1:length(varargin)  
    var = varargin{k};
    if isempty(var)
      continue
    end
    switch k
     case 1
      x1 = var;
     case 2
      r1 = var;
     case 3
      x2 = var;
     case 4
      r2 = var;
     case 5
      dq(1) = var*pi;
     case 6
      dq(2) = var*pi;
     case 7
      h = var;
     case 8
      nstep = var;
     case 9
      im = var;
    end
  end
  
  km=im/2-1;

  z=zeros(2*km+1,2);
  z(1+km,1)=x1; % center of vortex 1
  z(1+km+1,1)=r1; % radius of vortex 1

  z(1+km,2)=x2; % center of vortex 2
  z(1+km+1,2)=r2; % radius of vortex 2
  
  k=1:km;
  k2=-km:km;
  kw=[im-km+k-1,0:km];

  zi=sqrt(-1);
 
  %
  fm=4; % size of frame for drawing
  
  %
  t=0;
  z=c2rdst(z);
  handles = c2grph(t,z,fm);

  for istep=1:nstep
    ud = get(gcf, 'UserData');
    if strcmp(ud, 'stop') || strcmp(ud, 'exit')
      return;
    end
    [t,z]=tdrk4u(m,h,t,z,'c2fun');
    drawnow;
    z=c2rdst(z);
    drawnow;
    handles = c2grph(t,z,fm);
  end
